diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-tx-parameters.h ns-3.42/src/wifi/model/wifi-tx-parameters.h
--- ns-3.41/src/wifi/model/wifi-tx-parameters.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-tx-parameters.h	2024-05-29 15:29:47.216073800 -0700
@@ -27,6 +27,7 @@
 
 #include <map>
 #include <memory>
+#include <optional>
 #include <set>
 
 namespace ns3
@@ -61,10 +62,24 @@
      */
     WifiTxParameters& operator=(const WifiTxParameters& txParams);
 
+    /**
+     * Move constructor. Must define it manually because copy constructor is explicit.
+     * \param txParams the WifiTxParameters to copy
+     */
+    WifiTxParameters(WifiTxParameters&& txParams) = default;
+
+    /**
+     * Move assignment operator. Must define it manually because copy assignment
+     * operator is explicit.
+     * \param txParams the TX parameters to assign to this object
+     * \return the reference to this object
+     */
+    WifiTxParameters& operator=(WifiTxParameters&& txParams) = default;
+
     WifiTxVector m_txVector;                              //!< TXVECTOR of the frame being prepared
     std::unique_ptr<WifiProtection> m_protection;         //!< protection method
     std::unique_ptr<WifiAcknowledgment> m_acknowledgment; //!< acknowledgment method
-    Time m_txDuration{Time::Min()};                       //!< TX duration of the frame
+    std::optional<Time> m_txDuration;                     //!< TX duration of the frame
 
     /**
      * Reset the TX parameters.
@@ -74,12 +89,27 @@
     /**
      * Record that an MPDU is being added to the current frame. If an MPDU addressed
      * to the same receiver already exists in the frame, A-MPDU aggregation is considered.
+     * Store information needed to "undo" the addition of the MPDU by calling UndoAddMpdu().
      *
      * \param mpdu the MPDU being added
      */
     void AddMpdu(Ptr<const WifiMpdu> mpdu);
 
     /**
+     * Undo the addition of the last MPDU added by calling AddMpdu().
+     */
+    void UndoAddMpdu();
+
+    /**
+     * Check if the last added MPDU is the first MPDU for the given receiver.
+     * Call this method only after adding an MPDU for the given receiver.
+     *
+     * \param receiver the MAC address of the given receiver
+     * \return whether the last added MPDU is the first MPDU for the given receiver
+     */
+    bool LastAddedIsFirstMpdu(Mac48Address receiver) const;
+
+    /**
      * Record that an MSDU is being aggregated to the last MPDU added to the frame
      * that hase the same receiver.
      *
@@ -99,10 +129,9 @@
      * Get the size in bytes of the frame in case the given MSDU is aggregated.
      *
      * \param msdu the given MSDU
-     * \return a pair (size in bytes of the current A-MSDU, size in bytes of the frame)
-               in case the given MSDU is aggregated
+     * \return size in bytes of the frame in case the given MSDU is aggregated
      */
-    std::pair<uint32_t, uint32_t> GetSizeIfAggregateMsdu(Ptr<const WifiMpdu> msdu) const;
+    uint32_t GetSizeIfAggregateMsdu(Ptr<const WifiMpdu> msdu) const;
 
     /**
      * Get the size in bytes of the (A-)MPDU addressed to the given receiver.
@@ -150,8 +179,12 @@
     void Print(std::ostream& os) const;
 
   private:
-    PsduInfoMap m_info; //!< information about the frame being prepared. Handles
-                        //!< multi-TID A-MPDUs, MU PPDUs, etc.
+    PsduInfoMap m_info;    //!< information about the frame being prepared. Handles
+                           //!< multi-TID A-MPDUs, MU PPDUs, etc.
+    PsduInfo m_undoInfo{}; //!< information needed to undo the addition of an MPDU
+    std::optional<PsduInfoMap::iterator>
+        m_lastInfoIt; //!< iterator pointing to the entry in the m_info map
+                      //!< that was created/modified by the last added MPDU
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-tx-timer.cc ns-3.42/src/wifi/model/wifi-tx-timer.cc
--- ns-3.41/src/wifi/model/wifi-tx-timer.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-tx-timer.cc	2024-05-29 15:29:47.216073800 -0700
@@ -49,7 +49,7 @@
 {
     NS_LOG_FUNCTION(this << delay);
 
-    if (m_timeoutEvent.IsRunning())
+    if (m_timeoutEvent.IsPending())
     {
         NS_LOG_DEBUG("Rescheduling " << GetReasonString(m_reason) << " timeout in "
                                      << delay.As(Time::US));
@@ -120,7 +120,7 @@
 bool
 WifiTxTimer::IsRunning() const
 {
-    return m_timeoutEvent.IsRunning();
+    return m_timeoutEvent.IsPending();
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-tx-vector.cc ns-3.42/src/wifi/model/wifi-tx-vector.cc
--- ns-3.41/src/wifi/model/wifi-tx-vector.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/model/wifi-tx-vector.cc	2024-05-29 15:29:47.216073800 -0700
@@ -205,7 +205,7 @@
     if (IsMu())
     {
         NS_ABORT_MSG_IF(staId > 2048, "STA-ID should be correctly set for MU (" << staId << ")");
-        NS_ASSERT(m_muUserInfos.find(staId) != m_muUserInfos.end());
+        NS_ASSERT(m_muUserInfos.contains(staId));
         return m_muUserInfos.at(staId).nss;
     }
     return m_nss;
@@ -605,7 +605,7 @@
 bool
 WifiTxVector::IsAllocated(uint16_t staId) const
 {
-    return m_muUserInfos.count(staId) > 0;
+    return m_muUserInfos.contains(staId);
 }
 
 HeRu::RuSpec
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-utils.cc ns-3.42/src/wifi/model/wifi-utils.cc
--- ns-3.41/src/wifi/model/wifi-utils.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/model/wifi-utils.cc	2024-05-29 15:29:47.216073800 -0700
@@ -30,6 +30,8 @@
 namespace ns3
 {
 
+const Time WIFI_TU = MicroSeconds(WIFI_TU_US);
+
 double
 DbToRatio(double dB)
 {
@@ -57,9 +59,9 @@
 uint32_t
 GetAckSize()
 {
-    WifiMacHeader ack;
-    ack.SetType(WIFI_MAC_CTL_ACK);
-    return ack.GetSize() + 4;
+    static const uint32_t size = WifiMacHeader(WIFI_MAC_CTL_ACK).GetSize() + 4;
+
+    return size;
 }
 
 uint32_t
@@ -102,17 +104,17 @@
 uint32_t
 GetRtsSize()
 {
-    WifiMacHeader rts;
-    rts.SetType(WIFI_MAC_CTL_RTS);
-    return rts.GetSize() + 4;
+    static const uint32_t size = WifiMacHeader(WIFI_MAC_CTL_RTS).GetSize() + 4;
+
+    return size;
 }
 
 uint32_t
 GetCtsSize()
 {
-    WifiMacHeader cts;
-    cts.SetType(WIFI_MAC_CTL_CTS);
-    return cts.GetSize() + 4;
+    static const uint32_t size = WifiMacHeader(WIFI_MAC_CTL_CTS).GetSize() + 4;
+
+    return size;
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-utils.h ns-3.42/src/wifi/model/wifi-utils.h
--- ns-3.41/src/wifi/model/wifi-utils.h	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/model/wifi-utils.h	2024-05-29 15:29:47.216073800 -0700
@@ -23,6 +23,7 @@
 #include "block-ack-type.h"
 
 #include "ns3/fatal-error.h"
+#include "ns3/nstime.h"
 #include "ns3/ptr.h"
 
 #include <list>
@@ -194,6 +195,13 @@
 /// Invalid link identifier
 static constexpr uint8_t WIFI_LINKID_UNDEFINED = 0xff;
 
+/// Wi-Fi Time Unit value in microseconds (see IEEE 802.11-2020 sec. 3.1)
+/// Used to initialize WIFI_TU
+constexpr int WIFI_TU_US = 1024;
+
+/// Wi-Fi Time Unit (see IEEE 802.11-2020 sec. 3.1)
+extern const Time WIFI_TU;
+
 } // namespace ns3
 
 #endif /* WIFI_UTILS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/yans-wifi-channel.cc ns-3.42/src/wifi/model/yans-wifi-channel.cc
--- ns-3.41/src/wifi/model/yans-wifi-channel.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/model/yans-wifi-channel.cc	2024-05-29 15:29:47.216073800 -0700
@@ -134,18 +134,19 @@
 YansWifiChannel::Receive(Ptr<YansWifiPhy> phy, Ptr<const WifiPpdu> ppdu, double rxPowerDbm)
 {
     NS_LOG_FUNCTION(phy << ppdu << rxPowerDbm);
+    const auto totalRxPowerDbm = rxPowerDbm + phy->GetRxGain();
+    phy->TraceSignalArrival(ppdu, totalRxPowerDbm, ppdu->GetTxDuration());
     // Do no further processing if signal is too weak
     // Current implementation assumes constant RX power over the PPDU duration
     // Compare received TX power per MHz to normalized RX sensitivity
     uint16_t txWidth = ppdu->GetTxChannelWidth();
-    if ((rxPowerDbm + phy->GetRxGain()) < phy->GetRxSensitivity() + RatioToDb(txWidth / 20.0))
+    if (totalRxPowerDbm < phy->GetRxSensitivity() + RatioToDb(txWidth / 20.0))
     {
         NS_LOG_INFO("Received signal too weak to process: " << rxPowerDbm << " dBm");
         return;
     }
     RxPowerWattPerChannelBand rxPowerW;
-    rxPowerW.insert(
-        {{{0, 0}, {0, 0}}, (DbmToW(rxPowerDbm + phy->GetRxGain()))}); // dummy band for YANS
+    rxPowerW.insert({{{0, 0}, {0, 0}}, DbmToW(totalRxPowerDbm)}); // dummy band for YANS
     phy->StartReceivePreamble(ppdu, rxPowerW, ppdu->GetTxDuration());
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/yans-wifi-phy.cc ns-3.42/src/wifi/model/yans-wifi-phy.cc
--- ns-3.41/src/wifi/model/yans-wifi-phy.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/model/yans-wifi-phy.cc	2024-05-29 15:29:47.216073800 -0700
@@ -36,10 +36,15 @@
 TypeId
 YansWifiPhy::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::YansWifiPhy")
-                            .SetParent<WifiPhy>()
-                            .SetGroupName("Wifi")
-                            .AddConstructor<YansWifiPhy>();
+    static TypeId tid =
+        TypeId("ns3::YansWifiPhy")
+            .SetParent<WifiPhy>()
+            .SetGroupName("Wifi")
+            .AddConstructor<YansWifiPhy>()
+            .AddTraceSource("SignalArrival",
+                            "Trace start of all signal arrivals, including weak signals",
+                            MakeTraceSourceAccessor(&YansWifiPhy::m_signalArrivalCb),
+                            "ns3::YansWifiPhy::SignalArrivalCallback");
     return tid;
 }
 
@@ -89,9 +94,17 @@
     NS_LOG_FUNCTION(this << ppdu);
     NS_LOG_DEBUG("Start transmission: signal power before antenna gain="
                  << GetPowerDbm(ppdu->GetTxVector().GetTxPowerLevel()) << "dBm");
+    m_signalTransmissionCb(ppdu, ppdu->GetTxVector());
     m_channel->Send(this, ppdu, GetTxPowerForTransmission(ppdu) + GetTxGain());
 }
 
+void
+YansWifiPhy::TraceSignalArrival(Ptr<const WifiPpdu> ppdu, double rxPowerDbm, Time duration)
+{
+    NS_LOG_FUNCTION(this << ppdu);
+    m_signalArrivalCb(ppdu, rxPowerDbm, ppdu->GetTxDuration());
+}
+
 uint16_t
 YansWifiPhy::GetGuardBandwidth(uint16_t currentChannelWidth) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/yans-wifi-phy.h ns-3.42/src/wifi/model/yans-wifi-phy.h
--- ns-3.41/src/wifi/model/yans-wifi-phy.h	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/model/yans-wifi-phy.h	2024-05-29 15:29:47.216073800 -0700
@@ -73,11 +73,35 @@
      */
     void SetChannel(const Ptr<YansWifiChannel> channel);
 
+    /**
+     * Logs the arrival of a PPDU, including its power and duration.
+     * This will also trace PPDUs below WifiPhy::RxSensitivity
+     *
+     * \param [in] ppdu The PPDU being traced upon its arrival.
+     * \param [in] rxPowerDbm The received power of the PPDU in dBm.
+     * \param [in] duration The duration of the PPDU signal.
+     */
+    void TraceSignalArrival(Ptr<const WifiPpdu> ppdu, double rxPowerDbm, Time duration);
+
+    /**
+     * Callback invoked when the PHY model starts to process a signal
+     *
+     * \param ppdu The PPDU being processed
+     * \param rxPowerDbm received signal power (dBm)
+     * \param duration Signal duration
+     */
+    typedef void (*SignalArrivalCallback)(Ptr<const WifiPpdu> ppdu,
+                                          double rxPowerDbm,
+                                          Time duration);
+
   protected:
     void DoDispose() override;
 
   private:
     Ptr<YansWifiChannel> m_channel; //!< YansWifiChannel that this YansWifiPhy is connected to
+
+    TracedCallback<Ptr<const WifiPpdu>, double, Time>
+        m_signalArrivalCb; //!< Signal Arrival callback
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/80211b.c ns-3.42/src/wifi/test/80211b.c
--- ns-3.41/src/wifi/test/80211b.c	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/80211b.c	2024-05-29 15:29:47.216073800 -0700
@@ -17,9 +17,13 @@
  * Author: Gary Pei <guangyu.pei@boeing.com>
  */
 
-/*
+/**
+ * \file
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * This program is used to generate plots found in the paper
- * G. Pei and Tom Henderson, "Validation of ns-3 802.11b PHY model",
+ * Guangyu Pei and Tom Henderson, "Validation of ns-3 802.11b PHY model",
  * available online at http://www.nsnam.org/~pei/80211b.pdf
  *
  * It can be compiled as a C program and relies on a library installation of
@@ -33,6 +37,13 @@
  *   gnuplot 80211b.plt
  */
 
+/**
+ * \ingroup wifi
+ * \defgroup wifi-test wifi module tests
+ */
+
+#ifndef DOXYGEN_SHOULD_SKIP_THIS
+
 #include <gsl/gsl_cdf.h>
 #include <gsl/gsl_integration.h>
 #include <gsl/gsl_math.h>
@@ -43,17 +54,6 @@
 #define WLAN_SIR_perfect 10.0   // if SIR > 10dB, perfect reception
 #define WLAN_SIR_impossible 0.1 // if SIR < -10dB, impossible to receive
 
-/**
- * \ingroup wifi
- * \defgroup wifi-test wifi module tests
- */
-
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief fn_parameter_t structure
- */
 typedef struct fn_parameter_t
 {
     double beta; ///< beta
@@ -284,3 +284,5 @@
     }
     return 0;
 }
+
+#endif /* DOXYGEN_SHOULD_SKIP_THIS */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/block-ack-test-suite.cc ns-3.42/src/wifi/test/block-ack-test-suite.cc
--- ns-3.41/src/wifi/test/block-ack-test-suite.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/block-ack-test-suite.cc	2024-05-29 15:29:47.216073800 -0700
@@ -18,6 +18,7 @@
  */
 
 #include "ns3/ap-wifi-mac.h"
+#include "ns3/attribute-container.h"
 #include "ns3/boolean.h"
 #include "ns3/config.h"
 #include "ns3/ctrl-headers.h"
@@ -1903,6 +1904,14 @@
                 "BeaconGeneration",
                 BooleanValue(true));
 
+    if (m_txop)
+    {
+        // set the TXOP limit on BE AC
+        mac.SetEdca(AC_BE,
+                    "TxopLimits",
+                    AttributeContainerValue<TimeValue>(std::list{MicroSeconds(4800)}));
+    }
+
     NetDeviceContainer apDevices;
     apDevices = wifi.Install(phy, mac, wifiApNode);
 
@@ -1931,10 +1940,6 @@
         ptr.Get<QosTxop>()->TraceConnectWithoutContext(
             "TxopTrace",
             MakeCallback(&TxopDurationTracer::Trace, &txopTracer));
-
-        // set the TXOP limit on BE AC
-        ap_device->GetMac()->GetAttribute("BE_Txop", ptr);
-        ptr.Get<QosTxop>()->SetTxopLimit(MicroSeconds(4800));
     }
 
     PacketSocketAddress socket;
@@ -2018,17 +2023,17 @@
 };
 
 BlockAckTestSuite::BlockAckTestSuite()
-    : TestSuite("wifi-block-ack", UNIT)
+    : TestSuite("wifi-block-ack", Type::UNIT)
 {
-    AddTestCase(new PacketBufferingCaseA, TestCase::QUICK);
-    AddTestCase(new PacketBufferingCaseB, TestCase::QUICK);
-    AddTestCase(new OriginatorBlockAckWindowTest, TestCase::QUICK);
-    AddTestCase(new CtrlBAckResponseHeaderTest, TestCase::QUICK);
-    AddTestCase(new BlockAckRecipientBufferTest(0), TestCase::QUICK);
-    AddTestCase(new BlockAckRecipientBufferTest(4090), TestCase::QUICK);
-    AddTestCase(new MultiStaCtrlBAckResponseHeaderTest, TestCase::QUICK);
-    AddTestCase(new BlockAckAggregationDisabledTest(false), TestCase::QUICK);
-    AddTestCase(new BlockAckAggregationDisabledTest(true), TestCase::QUICK);
+    AddTestCase(new PacketBufferingCaseA, TestCase::Duration::QUICK);
+    AddTestCase(new PacketBufferingCaseB, TestCase::Duration::QUICK);
+    AddTestCase(new OriginatorBlockAckWindowTest, TestCase::Duration::QUICK);
+    AddTestCase(new CtrlBAckResponseHeaderTest, TestCase::Duration::QUICK);
+    AddTestCase(new BlockAckRecipientBufferTest(0), TestCase::Duration::QUICK);
+    AddTestCase(new BlockAckRecipientBufferTest(4090), TestCase::Duration::QUICK);
+    AddTestCase(new MultiStaCtrlBAckResponseHeaderTest, TestCase::Duration::QUICK);
+    AddTestCase(new BlockAckAggregationDisabledTest(false), TestCase::Duration::QUICK);
+    AddTestCase(new BlockAckAggregationDisabledTest(true), TestCase::Duration::QUICK);
 }
 
 static BlockAckTestSuite g_blockAckTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/channel-access-manager-test.cc ns-3.42/src/wifi/test/channel-access-manager-test.cc
--- ns-3.41/src/wifi/test/channel-access-manager-test.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/channel-access-manager-test.cc	2024-05-29 15:29:47.216073800 -0700
@@ -22,9 +22,11 @@
 #include "ns3/frame-exchange-manager.h"
 #include "ns3/interference-helper.h"
 #include "ns3/multi-model-spectrum-channel.h"
+#include "ns3/pointer.h"
 #include "ns3/qos-txop.h"
 #include "ns3/simulator.h"
 #include "ns3/spectrum-wifi-phy.h"
+#include "ns3/string.h"
 #include "ns3/test.h"
 
 #include <list>
@@ -638,7 +640,9 @@
     m_txop.push_back(txop);
     m_ChannelAccessManager->Add(txop);
     // the following causes the creation of a link for the txop object
-    auto mac = CreateObject<AdhocWifiMac>();
+    auto mac = CreateObjectWithAttributes<AdhocWifiMac>(
+        "Txop",
+        PointerValue(CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"))));
     mac->SetWifiPhys({nullptr});
     txop->SetWifiMac(mac);
     txop->SetAifsn(aifsn);
@@ -1538,9 +1542,9 @@
 };
 
 TxopTestSuite::TxopTestSuite()
-    : TestSuite("wifi-devices-dcf", UNIT)
+    : TestSuite("wifi-devices-dcf", Type::UNIT)
 {
-    AddTestCase(new ChannelAccessManagerTest<Txop>, TestCase::QUICK);
+    AddTestCase(new ChannelAccessManagerTest<Txop>, TestCase::Duration::QUICK);
 }
 
 static TxopTestSuite g_dcfTestSuite;
@@ -1558,9 +1562,9 @@
 };
 
 QosTxopTestSuite::QosTxopTestSuite()
-    : TestSuite("wifi-devices-edca", UNIT)
+    : TestSuite("wifi-devices-edca", Type::UNIT)
 {
-    AddTestCase(new ChannelAccessManagerTest<QosTxop>, TestCase::QUICK);
+    AddTestCase(new ChannelAccessManagerTest<QosTxop>, TestCase::Duration::QUICK);
 }
 
 static QosTxopTestSuite g_edcaTestSuite;
@@ -1578,9 +1582,9 @@
 };
 
 ChannelAccessManagerTestSuite::ChannelAccessManagerTestSuite()
-    : TestSuite("wifi-channel-access-manager", UNIT)
+    : TestSuite("wifi-channel-access-manager", Type::UNIT)
 {
-    AddTestCase(new LargestIdlePrimaryChannelTest, TestCase::QUICK);
+    AddTestCase(new LargestIdlePrimaryChannelTest, TestCase::Duration::QUICK);
 }
 
 static ChannelAccessManagerTestSuite g_camTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/inter-bss-test-suite.cc ns-3.42/src/wifi/test/inter-bss-test-suite.cc
--- ns-3.41/src/wifi/test/inter-bss-test-suite.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/inter-bss-test-suite.cc	2024-05-29 15:29:47.216073800 -0700
@@ -339,17 +339,17 @@
                         ap_device2,
                         WifiPhyState::TX);
     // All other PHYs should have stay idle until 4us (preamble detection time).
-    Simulator::Schedule(Seconds(2.0) + MicroSeconds(13),
+    Simulator::Schedule(Seconds(2.0) + MicroSeconds(11),
                         &TestInterBssConstantObssPdAlgo::CheckPhyState,
                         this,
                         sta_device1,
                         WifiPhyState::IDLE);
-    Simulator::Schedule(Seconds(2.0) + MicroSeconds(13),
+    Simulator::Schedule(Seconds(2.0) + MicroSeconds(11),
                         &TestInterBssConstantObssPdAlgo::CheckPhyState,
                         this,
                         sta_device2,
                         WifiPhyState::IDLE);
-    Simulator::Schedule(Seconds(2.0) + MicroSeconds(13),
+    Simulator::Schedule(Seconds(2.0) + MicroSeconds(11),
                         &TestInterBssConstantObssPdAlgo::CheckPhyState,
                         this,
                         ap_device1,
@@ -997,10 +997,12 @@
 };
 
 InterBssTestSuite::InterBssTestSuite()
-    : TestSuite("wifi-inter-bss", UNIT)
+    : TestSuite("wifi-inter-bss", Type::UNIT)
 {
-    AddTestCase(new TestInterBssConstantObssPdAlgo(WIFI_STANDARD_80211ax), TestCase::QUICK);
-    AddTestCase(new TestInterBssConstantObssPdAlgo(WIFI_STANDARD_80211be), TestCase::QUICK);
+    AddTestCase(new TestInterBssConstantObssPdAlgo(WIFI_STANDARD_80211ax),
+                TestCase::Duration::QUICK);
+    AddTestCase(new TestInterBssConstantObssPdAlgo(WIFI_STANDARD_80211be),
+                TestCase::Duration::QUICK);
 }
 
 // Do not forget to allocate an instance of this TestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/power-rate-adaptation-test.cc ns-3.42/src/wifi/test/power-rate-adaptation-test.cc
--- ns-3.41/src/wifi/test/power-rate-adaptation-test.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/power-rate-adaptation-test.cc	2024-05-29 15:29:47.216073800 -0700
@@ -23,7 +23,9 @@
 #include "ns3/frame-exchange-manager.h"
 #include "ns3/interference-helper.h"
 #include "ns3/node.h"
+#include "ns3/pointer.h"
 #include "ns3/simulator.h"
+#include "ns3/string.h"
 #include "ns3/test.h"
 #include "ns3/wifi-default-ack-manager.h"
 #include "ns3/wifi-default-protection-manager.h"
@@ -115,11 +117,15 @@
     /*
      * Create mac layer. We use Adhoc because association is not needed to get supported rates.
      */
-    Ptr<AdhocWifiMac> mac = CreateObject<AdhocWifiMac>();
+    auto mac = CreateObjectWithAttributes<AdhocWifiMac>(
+        "Txop",
+        PointerValue(CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"))));
     mac->SetDevice(dev);
     mac->SetAddress(Mac48Address::Allocate());
     dev->SetMac(mac);
-    mac->ConfigureStandard(WIFI_STANDARD_80211a);
+    mac->SetChannelAccessManagers({CreateObject<ChannelAccessManager>()});
+    mac->SetFrameExchangeManagers({CreateObject<FrameExchangeManager>()});
+    mac->GetFrameExchangeManager(SINGLE_LINK_OP_ID)->SetAddress(mac->GetAddress());
     mac->SetMacQueueScheduler(CreateObject<FcfsWifiQueueScheduler>());
     Ptr<FrameExchangeManager> fem = mac->GetFrameExchangeManager();
 
@@ -1168,9 +1174,9 @@
 };
 
 PowerRateAdaptationTestSuite::PowerRateAdaptationTestSuite()
-    : TestSuite("wifi-power-rate-adaptation", UNIT)
+    : TestSuite("wifi-power-rate-adaptation", Type::UNIT)
 {
-    AddTestCase(new PowerRateAdaptationTest, TestCase::QUICK);
+    AddTestCase(new PowerRateAdaptationTest, TestCase::Duration::QUICK);
 }
 
 static PowerRateAdaptationTestSuite g_powerRateAdaptationTestSuite; ///< the test suite
